﻿// Points.cpp : コンソール アプリケーションのエントリ ポイントを定義します。[
//

#include "stdafx.h"
#include "math.h"
#include "string.h"
#include "time.h"
#include <cstdio>
#include <stdlib.h>
#include <iostream>

long read_input(), sort_month(), sort_all(), smoothing_month(), calc_ratio_contours(), calc_ks(), read_input_yamap(), calc_model_exponential(), calc_model_exponential_all(), calc_model_logistic(), calc_model_logistic_all();

static long city_month_n_visitors[2000][40], city_month_n_yamaps[2000][40];

static long angle_month_visitor_r[99][40][2000], angle_season_visitor_r[99][5][9000], angle_year_visitor_r[99][4][9000], angle_visitor_r[99][22000], angle_r_max[99];

static long angle_month_yamap_r[99][40][3000], angle_season_yamap_r[99][5][25000], angle_year_yamap_r[99][4][25000], angle_yamap_r[99][70000];

static double city_x[2000], city_y[2000], city_area[2000], city_r[2000], azuma_x, azuma_y, lamda_origin, lamda_scale;

static double angle_year_lamda[99][4], angle_season_lamda[99][5], angle_year_lamda_smoothed[99][4], angle_season_lamda_smoothed[99][5];

static double angle_month_ratio_visitor_r[99][40][11], angle_month_ratio_visitor_smoothed_r[99][40][11], angle_month_ratio_visitor_smoothed_x[99][40][11], angle_month_ratio_visitor_smoothed_y[99][40][11];

static double angle_season_ratio_visitor_r[99][5][11], angle_season_ratio_visitor_smoothed_r[99][5][11], angle_season_ratio_visitor_smoothed_x[99][5][11], angle_season_ratio_visitor_smoothed_y[99][5][11];

static double angle_year_ratio_visitor_r[99][4][11], angle_year_ratio_visitor_smoothed_r[99][4][11], angle_year_ratio_visitor_smoothed_x[99][4][11], angle_year_ratio_visitor_smoothed_y[99][4][11];

static double angle_ratio_visitor_r[99][11], angle_ratio_visitor_smoothed_r[99][11], angle_ratio_visitor_smoothed_x[99][11], angle_ratio_visitor_smoothed_y[99][11];

static long angle_month_n_visitors[99][40], angle_n_visitors[99], angle_season_n_visitors[99][5], angle_year_n_visitors[99][4];

static long angle_month_n_yamaps[99][40], angle_n_yamaps[99], angle_season_n_yamaps[99][5], angle_year_n_yamaps[99][4];

static long n_cities, n_months, n_seasons, n_years, n_ratios, ratio, n_visitors, n_visitors_max_month, n_visitors_max_season, n_visitors_max_year, n_visitors_max, visitor1, visitor2;

static long n_yamaps_max, n_yamaps_max_month, n_yamaps_max_season, n_yamaps_max_year;

static long month_to_season[40], month_to_year[40];

static long yamap_ratio, estimation_n_repeats, estimation_repeat;

static long i, j, month, season, year, id, city, yamap, city_to_id[2000], id_to_city[50000], visitor, angle, angle_tmp, angle_smooth_width, angle_st, angle_en, n_angles, angle_st1, angle_st2, angle_en1, angle_en2;

static double ii, xx, yy, area, pi, uu, vv, theta, rr, dx, dy, angle_interval, ks, ks_max, ks_min;

static double alpha, alpha_min[99], alpha_max[99], alpha_interval[99], likelihood, likelihood_max, beta, beta_min[99], beta_max[99], beta_interval[99], alpha_scale;

static double alpha_min_all, alpha_max_all, alpha_interval_all, beta_min_all, beta_max_all, beta_interval_all, mu_min_all, mu_max_all, mu_interval_all;

static double mu, mu_min[99], mu_max[99], mu_interval[99];

static double angle_alpha_log_max[99], angle_beta_log_max[99], angle_mu_log_max[99], angle_alpha_log_max_smoothed[99], angle_beta_log_max_smoothed[99], angle_mu_log_max_smoothed[99], alpha_log_max, beta_log_max, mu_log_max, alpha_log_max_all, beta_log_max_all, mu_log_max_all;

char file_name_season_50[5][100], file_name_season_75[5][100], file_name_year_50[4][100], file_name_year_75[4][100], text_season[30], text_year[30], file_name_year_ks[4][100], file_name_season_ks[5][100];

FILE* fpp_out_all_50, * fpp_out_all_75, * fpp_out_lamda, * fpp_out_lamda_smoothed, * fpp_out_lamda_all, * fpp_out_angle0, * fpp_out_season_50[5][100], * fpp_out_season_75[5][100], * fpp_out_year_50[4][100], * fpp_out_year_75[4][100], * fpp_out_year_ks[4][100], * fpp_out_season_ks[5][100];

int main()
{

	errno_t error;

	int sub;

	pi = 3.141592654;  n_months = 36; n_seasons = 4; n_years = 3; n_ratios = 4; lamda_origin = 100.0; lamda_scale = 2000.0; yamap_ratio = 50;
	
	azuma_x = (15585384.073116 + 15621956.068122) / 2.0;  azuma_y = (4522312.408154 + 4557881.610027) / 2.0;

	n_angles = 96; angle_smooth_width = 9;  angle_interval = 2.0 * pi / (double)n_angles;

	estimation_n_repeats = 10;

//	alpha_min_all = 0.0; alpha_max_all = 2000.0; alpha_interval_all = 100.0; alpha_scale = 10000000.0;

	alpha_min_all = 0.0; alpha_max_all = 1.0; alpha_interval_all = 0.1; alpha_scale = 100000.0;

	alpha_min_all = alpha_min_all / alpha_scale; alpha_max_all = alpha_max_all / alpha_scale; alpha_interval_all = alpha_interval_all / alpha_scale;

	beta_min_all = 0.5; beta_max_all = 1.0; beta_interval_all = 0.1;

	mu_min_all = 0.0; mu_max_all = 1200000.0; mu_interval_all = 100000.0;

// alpha_min = 0.000010; alpha_max = 0.000020; alpha_interval = 0.000001; beta = 20.0 / 300.0;

	fopen_s(&fpp_out_all_50, "Azuma_all_50.csv", "w+");

	fopen_s(&fpp_out_all_75, "Azuma_all_75.csv", "w+");

	fopen_s(&fpp_out_lamda, "Lamda.csv", "w+");

	fopen_s(&fpp_out_lamda_smoothed, "Lamda_smoothed.csv", "w+");

	fopen_s(&fpp_out_lamda_all, "Lamda_all.csv", "w+");

	fopen_s(&fpp_out_angle0, "Angle0.csv", "w+");

	for (season = 1; season <= n_seasons; season++) {

		strcpy_s(file_name_season_50[season], "Azuma_season_50_0");

		_itoa_s(season, text_season, 10);

		strcat_s(file_name_season_50[season], text_season);	 strcat_s(file_name_season_50[season], ".csv");

		strcpy_s(file_name_season_75[season], "Azuma_season_75_0");

		_itoa_s(season, text_season, 10);

		strcat_s(file_name_season_75[season], text_season);	 strcat_s(file_name_season_75[season], ".csv");

		strcpy_s(file_name_season_ks[season], "Azuma_season_ks_0");

		_itoa_s(season, text_season, 10);

		strcat_s(file_name_season_ks[season], text_season);	 strcat_s(file_name_season_ks[season], ".csv");

		fopen_s(fpp_out_season_50[season], file_name_season_50[season], "w+");

		fopen_s(fpp_out_season_75[season], file_name_season_75[season], "w+");

		fopen_s(fpp_out_season_ks[season], file_name_season_ks[season], "w+");

		fprintf(*fpp_out_season_50[season], " ID,           X,           Y\n");

		fprintf(*fpp_out_season_75[season], " ID,           X,           Y\n");

		fprintf(*fpp_out_season_ks[season], " ID,           Lamda,                  x,                 y\n");

	}

	for (year = 1; year <= n_years; year++) {

		strcpy_s(file_name_year_50[year], "Azuma_year_50_0");

		_itoa_s(year, text_year, 10);

		strcat_s(file_name_year_50[year], text_year);	 strcat_s(file_name_year_50[year], ".csv");

		strcpy_s(file_name_year_75[year], "Azuma_year_75_0");

		_itoa_s(year, text_year, 10);

		strcat_s(file_name_year_75[year], text_year);	 strcat_s(file_name_year_75[year], ".csv");

		strcpy_s(file_name_year_ks[year], "Azuma_year_ks_0");

		_itoa_s(year, text_year, 10);

		strcat_s(file_name_year_ks[year], text_year);	 strcat_s(file_name_year_ks[year], ".csv");

		fopen_s(fpp_out_year_50[year], file_name_year_50[year], "w+");

		fopen_s(fpp_out_year_75[year], file_name_year_75[year], "w+");

		fopen_s(fpp_out_year_ks[year], file_name_year_ks[year], "w+");

		fprintf(*fpp_out_year_50[year], " ID,           X,           Y\n");

		fprintf(*fpp_out_year_75[year], " ID,           X,           Y\n");

		fprintf(*fpp_out_year_ks[year], " ID,           Lamda,                  x,                 y\n");

	}

	for (month = 1; month <= n_months; month++) {

		if ((3 <= month && month <= 5) || (15 <= month && month <= 17) || (27 <= month && month <= 29)) { month_to_season[month] = 1; }

		else if ((6 <= month && month <= 8) || (18 <= month && month <= 20) || (30 <= month && month <= 32)) { month_to_season[month] = 2; }

		else if ((9 <= month && month <= 11) || (21 <= month && month <= 23) || (33 <= month && month <= 35)) { month_to_season[month] = 3; }

		else { month_to_season[month] = 4; }

		if (month <= 12) { month_to_year[month] = 1; }

		else if (month <= 24) { month_to_year[month] = 2; }

		else { month_to_year[month] = 3; }

	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_n_visitors[angle] = angle_n_yamaps[angle] = 0;

		for (month = 1; month <= n_months; month++) {

			angle_month_n_visitors[angle][month] = angle_month_n_yamaps[angle][month] = 0;

		}

		for (season = 1; season <= n_seasons; season++) {

			angle_season_n_visitors[angle][season] = angle_season_n_yamaps[angle][season] = 0;

		}

		for (year = 1; year <= n_years; year++) {

			angle_year_n_visitors[angle][year] = angle_year_n_yamaps[angle][year] = 0;

		}

	}

	sub = read_input();

//	sub = sort_month();

//	sub = sort_all();

//	sub = calc_ratio_contours();

//	sub = calc_ks();

	sub = read_input_yamap();

//	sub = city_to_angle_transformation_yamap();

//	sub = calc_model_exponential();

	sub = calc_model_exponential_all();

//	sub = calc_model_logistic();

//	sub = calc_model_logistic_all();

	printf("End\n");

}

long calc_model_logistic_all() {

	likelihood_max = -10000000000000.0;

	for (estimation_repeat = 1; estimation_repeat <= estimation_n_repeats; estimation_repeat++) {

		for (mu = mu_min_all; mu <= mu_max_all; mu = mu + mu_interval_all) {

			for (beta = beta_min_all; beta <= beta_max_all; beta = beta + beta_interval_all) {

				for (alpha = alpha_min_all; alpha <= alpha_max_all; alpha = alpha + alpha_interval_all) {

					likelihood = 0.0;

					for (angle = 1; angle <= n_angles; angle++) {

						for (visitor = 1; visitor <= angle_n_visitors[angle]; visitor++) {

							likelihood = likelihood + log(1.0 - beta / (1.0 + exp(-alpha * (angle_visitor_r[angle][visitor] - mu))));

							// printf("Angle %3d Visitor: %6d Alpha: %16.10f Beta: %6.4f Mu: %8.0f R %16d Prob %16.10f\n", angle, visitor, alpha, beta, mu, angle_visitor_r[angle][visitor], beta / (1.0 + exp(-alpha * ( angle_visitor_r[angle][visitor] - mu))));

													//				printf("Alpha: %16.10f Visitor: %6d Likelihood: %16.10f\n", alpha, visitor, likelihood);

						}

						//				printf("Angle1: %3d Alpha: %16.10f Beta: %16.10f Likelihood: %16.10f\n", angle, alpha, beta, likelihood);

						for (yamap = 1; yamap <= angle_n_yamaps[angle]; yamap++) {

							likelihood = likelihood + log(beta / (1.0 + exp(-alpha * (angle_yamap_r[angle][yamap] - mu))));


							//				printf("Alpha: %16.10f Yamap: %6d Likelihood2: %16.10f\n", alpha, yamap, likelihood);

						}

						if (likelihood_max < likelihood) { likelihood_max = likelihood; alpha_log_max_all = alpha; beta_log_max_all = beta; mu_log_max_all = mu; }

						// printf("Angle %3d Alpha: %16.10f Beta: %6.4f Mu: %8.0f R %16d Prob %16.10f Likelihood: %16.10f\n", angle, alpha, beta, mu, angle_visitor_r[angle][visitor], beta / (1.0 + exp(-alpha * (angle_visitor_r[angle][visitor] - mu))), likelihood);

					}

				}

			}

		}

		alpha_min_all = alpha_log_max_all - alpha_interval_all; alpha_max_all = alpha_log_max_all + alpha_interval_all; alpha_interval_all = alpha_interval_all / 10.0;

		beta_min_all = beta_log_max_all - beta_interval_all; beta_max_all = beta_log_max_all + beta_interval_all; beta_interval_all = beta_interval_all / 10.0;

		mu_min_all = mu_log_max_all - mu_interval_all; mu_max_all = mu_log_max_all + mu_interval_all; mu_interval_all = mu_interval_all / 10.0;

		if (alpha_min_all < 0.0) { alpha_min_all = 0.0; }

		if (beta_min_all < 0.0) { beta_min_all = 0.0; }

		if (mu_min_all < 0.0) { mu_min_all = 0.0; }

	}

	printf("%10.5f, %9.5f, %12.4f, %14.6f, %10.7f, %10.7f\n"

		, alpha_log_max_all* alpha_scale, beta_log_max_all, mu_log_max_all, likelihood_max

		, 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (100000.0 - mu_log_max_all))), 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (200000.0 - mu_log_max_all))));

	fprintf(fpp_out_lamda_all, "%10.5f, %9.5f, %12.4f, %14.6f, %10.7f, %10.7f\n"

		, alpha_log_max_all* alpha_scale, beta_log_max_all, mu_log_max_all, likelihood_max

		, 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (100000.0 - mu_log_max_all))), 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (200000.0 - mu_log_max_all))));

	return(0);

}

long calc_model_logistic() {

	for (angle = 1; angle <= n_angles; angle++) {

		alpha_min[angle] = 0.0; alpha_max[angle] = 350.0; alpha_interval[angle] = 10.0; alpha_scale = 10000000.0;

		alpha_min[angle] = alpha_min[angle] / alpha_scale; alpha_max[angle] = alpha_max[angle] / alpha_scale; alpha_interval[angle] = alpha_interval[angle] / alpha_scale;

		beta_min[angle] = 0.8; beta_max[angle] = 0.8; beta_interval[angle] = 0.1;

		mu_min[angle] = 0.0; mu_max[angle] = 1200000.0; mu_interval[angle] = 100000.0;

	}

	for (angle = 1; angle <= 46; angle++) {

		alpha_min[angle] = 0.0; alpha_max[angle] = 100.0; alpha_interval[angle] = 10.0; alpha_scale = 10000000.0;

		alpha_min[angle] = alpha_min[angle] / alpha_scale; alpha_max[angle] = alpha_max[angle] / alpha_scale; alpha_interval[angle] = alpha_interval[angle] / alpha_scale;

	}

	for (angle = 62; angle <= 64; angle++) {

		alpha_min[angle] = 900.0; alpha_max[angle] = 1300.0; alpha_interval[angle] = 10.0; alpha_scale = 10000000.0;

		alpha_min[angle] = alpha_min[angle] / alpha_scale; alpha_max[angle] = alpha_max[angle] / alpha_scale; alpha_interval[angle] = alpha_interval[angle] / alpha_scale;

	}

	printf("Angle, Visitors, Members,  Alpha_max,  Beta_max,       Mu_max, Likelihood_max,    Prob100,    Prob200\n");

	fprintf(fpp_out_lamda, "Angle, Visitors, Members,  Alpha_max,  Beta_max,       Mu_max, Likelihood_max,    Prob100,    Prob200\n");

	fprintf(fpp_out_lamda_smoothed, "Angle, Visitors, Members,  Alpha_max,  Beta_max,       Mu_max, Likelihood_max,    Prob100,    Prob200\n");

	for (angle = 1; angle <= n_angles; angle++) {

		likelihood_max = -10000000000000.0;

		for (estimation_repeat = 1; estimation_repeat <= estimation_n_repeats; estimation_repeat++) {

			for (mu = mu_min[angle]; mu <= mu_max[angle]; mu = mu + mu_interval[angle]) {

				for (beta = beta_min[angle]; beta <= beta_max[angle]; beta = beta + beta_interval[angle]) {

					for (alpha = alpha_min[angle]; alpha <= alpha_max[angle]; alpha = alpha + alpha_interval[angle]) {

						likelihood = 0.0;

						for (visitor = 1; visitor <= angle_n_visitors[angle]; visitor++) {

							likelihood = likelihood + log(1.0 - beta / (1.0 + exp(-alpha * (angle_visitor_r[angle][visitor] - mu))));

							// printf("Angle %3d Visitor: %6d Alpha: %16.10f Beta: %6.4f Mu: %8.0f R %16d Prob %16.10f\n", angle, visitor, alpha, beta, mu, angle_visitor_r[angle][visitor], beta / (1.0 + exp(-alpha * ( angle_visitor_r[angle][visitor] - mu))));

													//				printf("Alpha: %16.10f Visitor: %6d Likelihood: %16.10f\n", alpha, visitor, likelihood);

						}

						//				printf("Angle1: %3d Alpha: %16.10f Beta: %16.10f Likelihood: %16.10f\n", angle, alpha, beta, likelihood);

						for (yamap = 1; yamap <= angle_n_yamaps[angle]; yamap++) {

							likelihood = likelihood + log(beta / (1.0 + exp(-alpha * (angle_yamap_r[angle][yamap] - mu))));


							//				printf("Alpha: %16.10f Yamap: %6d Likelihood2: %16.10f\n", alpha, yamap, likelihood);

						}

						if (likelihood_max < likelihood) { likelihood_max = likelihood; alpha_log_max = alpha; beta_log_max = beta; mu_log_max = mu; }

						// printf("Angle %3d Alpha: %16.10f Beta: %6.4f Mu: %8.0f R %16d Prob %16.10f Likelihood: %16.10f\n", angle, alpha, beta, mu, angle_visitor_r[angle][visitor], beta / (1.0 + exp(-alpha * (angle_visitor_r[angle][visitor] - mu))), likelihood);

					}

				}

			}

			alpha_min[angle] = alpha_log_max - alpha_interval[angle]; alpha_max[angle] = alpha_log_max + alpha_interval[angle]; alpha_interval[angle] = alpha_interval[angle] / 10.0;

//			beta_min[angle] = beta_log_max - beta_interval[angle]; beta_max[angle] = beta_log_max + beta_interval[angle]; beta_interval[angle] = beta_interval[angle] / 10.0;

			mu_min[angle] = mu_log_max - mu_interval[angle]; mu_max[angle] = mu_log_max + mu_interval[angle]; mu_interval[angle] = mu_interval[angle] / 10.0;

			if (alpha_min[angle] < 0.0) { alpha_min[angle] = 0.0; }

//			if (beta_min[angle] < 0.0) { beta_min[angle] = 0.0; }

			if (mu_min[angle] < 0.0) { mu_min[angle] = 0.0; }

		}

		angle_alpha_log_max[angle] = alpha_log_max; angle_beta_log_max[angle] = beta_log_max; angle_mu_log_max[angle] = mu_log_max;

		printf("%5d, %8d, %7d, %10.5f, %9.5f, %12.4f, %14.6f, %10.7f, %10.7f\n"

			, angle, angle_n_visitors[angle], angle_n_yamaps[angle], angle_alpha_log_max[angle] * alpha_scale, angle_beta_log_max[angle], angle_mu_log_max[angle], likelihood_max

			, 1.0 - angle_beta_log_max[angle] / (1.0 + exp(-angle_alpha_log_max[angle] * (100000.0 - angle_mu_log_max[angle]))), 1.0 - angle_beta_log_max[angle] / (1.0 + exp(-angle_alpha_log_max[angle] * (200000.0 - angle_mu_log_max[angle]))));

		fprintf(fpp_out_lamda, "%5d, %8d, %7d, %10.5f, %9.5f, %12.4f, %14.6f, %10.7f, %10.7f\n"

			, angle, angle_n_visitors[angle], angle_n_yamaps[angle], angle_alpha_log_max[angle] * alpha_scale, angle_beta_log_max[angle], angle_mu_log_max[angle], likelihood_max

			, 1.0 - angle_beta_log_max[angle] / (1.0 + exp(-angle_alpha_log_max[angle] * (100000.0 - angle_mu_log_max[angle]))), 1.0 - angle_beta_log_max[angle] / (1.0 + exp(-angle_alpha_log_max[angle] * (200000.0 - angle_mu_log_max[angle]))));

	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_alpha_log_max_smoothed[angle] = angle_beta_log_max_smoothed[angle] = angle_mu_log_max_smoothed[angle] = 0.0;

	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_st = angle - angle_smooth_width; angle_en = angle + angle_smooth_width;

		if (angle_st < 1) { angle_st1 = 1; angle_en1 = angle_en; angle_st2 = n_angles + angle_st; angle_en2 = n_angles; }

		else if (n_angles < angle_en) { angle_st1 = angle_st; angle_en1 = n_angles; angle_st2 = 1; angle_en2 = angle_en - n_angles; }

		else { angle_st1 = angle_st; angle_en1 = angle_en;  angle_st2 = 1; angle_en2 = 0; }

		for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

			angle_alpha_log_max_smoothed[angle] = angle_alpha_log_max_smoothed[angle] + angle_alpha_log_max[angle_tmp];

			angle_beta_log_max_smoothed[angle] = angle_beta_log_max_smoothed[angle] + angle_beta_log_max[angle_tmp];

			angle_mu_log_max_smoothed[angle] = angle_mu_log_max_smoothed[angle] + angle_mu_log_max[angle_tmp];

		}

		for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

			angle_alpha_log_max_smoothed[angle] = angle_alpha_log_max_smoothed[angle] + angle_alpha_log_max[angle_tmp];

			angle_beta_log_max_smoothed[angle] = angle_beta_log_max_smoothed[angle] + angle_beta_log_max[angle_tmp];

			angle_mu_log_max_smoothed[angle] = angle_mu_log_max_smoothed[angle] + angle_mu_log_max[angle_tmp];

		}

		angle_alpha_log_max_smoothed[angle] = angle_alpha_log_max_smoothed[angle] / (angle_smooth_width * 2 + 1);

		angle_beta_log_max_smoothed[angle] = angle_beta_log_max_smoothed[angle] / (angle_smooth_width * 2 + 1);

		angle_mu_log_max_smoothed[angle] = angle_mu_log_max_smoothed[angle] / (angle_smooth_width * 2 + 1);

		printf("%5d, %8d, %7d, %10.5f, %9.5f, %12.4f, %14.6f, %10.7f, %10.7f\n"

			, angle, angle_n_visitors[angle], angle_n_yamaps[angle], angle_alpha_log_max_smoothed[angle] * alpha_scale, angle_beta_log_max_smoothed[angle], angle_mu_log_max_smoothed[angle], likelihood_max

			, 1.0 - angle_beta_log_max_smoothed[angle] / (1.0 + exp(-angle_alpha_log_max_smoothed[angle] * (100000.0 - angle_mu_log_max_smoothed[angle]))), 1.0 - angle_beta_log_max_smoothed[angle] / (1.0 + exp(-angle_alpha_log_max_smoothed[angle] * (200000.0 - angle_mu_log_max_smoothed[angle]))));

		fprintf(fpp_out_lamda_smoothed, "%5d, %8d, %7d, %10.5f, %9.5f, %12.4f, %14.6f, %10.7f, %10.7f\n"

			, angle, angle_n_visitors[angle], angle_n_yamaps[angle], angle_alpha_log_max_smoothed[angle] * alpha_scale, angle_beta_log_max_smoothed[angle], angle_mu_log_max_smoothed[angle], likelihood_max

			, 1.0 - angle_beta_log_max_smoothed[angle] / (1.0 + exp(-angle_alpha_log_max_smoothed[angle] * (100000.0 - angle_mu_log_max_smoothed[angle]))), 1.0 - angle_beta_log_max_smoothed[angle] / (1.0 + exp(-angle_alpha_log_max_smoothed[angle] * (200000.0 - angle_mu_log_max_smoothed[angle]))));

	}

	return(0);

}

long calc_model_exponential_all() {

	likelihood_max = -10000000000000.0;

	for (estimation_repeat = 1; estimation_repeat <= estimation_n_repeats; estimation_repeat++) {

		for (beta = beta_min_all; beta <= beta_max_all; beta = beta + beta_interval_all) {

			for (alpha = alpha_min_all; alpha <= alpha_max_all; alpha = alpha + alpha_interval_all) {

				likelihood = log(beta) * n_visitors;

				for (angle = 1; angle <= n_angles; angle++) {

					for (visitor = 1; visitor <= angle_n_visitors[angle]; visitor++) {

						likelihood = likelihood - alpha * angle_visitor_r[angle][visitor];

					}

					for (yamap = 1; yamap <= angle_n_yamaps[angle]; yamap++) {

						likelihood = likelihood + log(1.0 - beta * exp(-alpha * angle_yamap_r[angle][yamap]));

					}

				}

//				printf("Alpha: %16.14f Beta: %16.14f Likelihood: %16.8f\n", alpha, beta, likelihood);

				if (likelihood_max < likelihood) { likelihood_max = likelihood; alpha_log_max_all = alpha; beta_log_max_all = beta; }

			}

		}

		alpha_min_all = alpha_log_max_all - alpha_interval_all; alpha_max_all = alpha_log_max_all + alpha_interval_all; alpha_interval_all = alpha_interval_all / 10.0;

		beta_min_all = beta_log_max_all - beta_interval_all; beta_max_all = beta_log_max_all + beta_interval_all; beta_interval_all = beta_interval_all / 10.0;

		printf("%16.12f % 16.12f\n", alpha_log_max_all, beta_log_max_all);

		if (alpha_min_all < 0.0) { alpha_min_all = 0.0; }

		if (beta_min_all < 0.0) { beta_min_all = 0.0; }

	}

	printf("%10.5f, %9.5f, %14.6f, %10.7f, %10.7f\n"

		, alpha_log_max_all * alpha_scale, beta_log_max_all, likelihood_max

		, 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (100000.0 - mu_log_max_all))), 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (200000.0 - mu_log_max_all))));

	fprintf(fpp_out_lamda_all, "%10.5f, %9.5f, %14.6f, %10.7f, %10.7f\n"

		, alpha_log_max_all * alpha_scale, beta_log_max_all, likelihood_max

		, 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (100000.0 - mu_log_max_all))), 1.0 - beta_log_max_all / (1.0 + exp(-alpha_log_max_all * (200000.0 - mu_log_max_all))));

	return(0);

}

long calc_model_exponential() {

	for (angle = 1; angle <= n_angles; angle++) {

		alpha_min[angle] = 0.0; alpha_max[angle] = 100.0; alpha_interval[angle] = 10.0; alpha_scale = 10000000.0;

		alpha_min[angle] = alpha_min[angle] / alpha_scale; alpha_max[angle] = alpha_max[angle] / alpha_scale; alpha_interval[angle] = alpha_interval[angle] / alpha_scale;

	}

	beta = 0.80398;

	printf("Angle, Visitors, Members, Alpha_max, Beta_max, Likelihood_max\n");

	fprintf(fpp_out_lamda, "Angle, Visitors, Members, Alpha_max, Beta_max, Likelihood_max\n");

	for (angle = 1; angle <= n_angles; angle++) {

		likelihood_max = -10000000000000.0;

		for (estimation_repeat = 1; estimation_repeat <= estimation_n_repeats; estimation_repeat++) {

			for (alpha = alpha_min[angle]; alpha <= alpha_max[angle]; alpha = alpha + alpha_interval[angle]) {

				likelihood = log(beta) * angle_n_visitors[angle];

				for (visitor = 1; visitor <= angle_n_visitors[angle]; visitor++) {

					likelihood = likelihood - alpha * angle_visitor_r[angle][visitor];

					//				printf("Alpha: %16.10f Visitor: %6d R %16d Prob %16.10f\n", alpha, visitor, angle_visitor_r[angle][visitor], beta * exp(-alpha * angle_visitor_r[angle][visitor]));

					//				printf("Alpha: %16.10f Visitor: %6d Likelihood: %16.10f\n", alpha, visitor, likelihood);

				}

				//				printf("Angle1: %3d Alpha: %16.10f Beta: %16.10f Likelihood: %16.10f\n", angle, alpha, beta, likelihood);

				for (yamap = 1; yamap <= angle_n_yamaps[angle]; yamap++) {

					likelihood = likelihood + log(1.0 - beta * exp(-alpha * angle_yamap_r[angle][yamap]));

					//				printf("Alpha: %16.10f Yamap: %6d Likelihood2: %16.10f\n", alpha, yamap, likelihood);

				}

				if (likelihood_max < likelihood) { likelihood_max = likelihood; alpha_log_max = alpha; }

				//				printf("Angle2: %3d Alpha: %16.10f Beta: %16.10f Likelihood: %16.10f\n", angle, alpha, beta, likelihood);

			}

			alpha_min[angle] = alpha_log_max - alpha_interval[angle]; alpha_max[angle] = alpha_log_max + alpha_interval[angle]; alpha_interval[angle] = alpha_interval[angle] / 10.0;

			if (alpha_min[angle] < 0.0) { alpha_min[angle] = 0.0; }

		}

		angle_alpha_log_max[angle] = alpha_log_max;

		printf("%5d, %7d, %6d, %9.5f, %9.5f, %12.4f, %10.7f, %10.7f\n"
			, angle, angle_n_visitors[angle], angle_n_yamaps[angle], alpha_log_max * alpha_scale, beta_log_max, likelihood_max, beta * exp(-alpha_log_max * 100000.0), beta * exp(-alpha_log_max * 200000.0));

		fprintf(fpp_out_lamda, "%5d, %7d, %6d, %9.5f, %9.5f, %12.4f, %10.7f, %10.7f\n"
			, angle, angle_n_visitors[angle], angle_n_yamaps[angle], alpha_log_max * alpha_scale, beta_log_max, likelihood_max, beta * exp(-alpha_log_max * 100000.0), beta * exp(-alpha_log_max * 200000.0));

	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_alpha_log_max_smoothed[angle] = 0.0;

	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_st = angle - angle_smooth_width; angle_en = angle + angle_smooth_width;

		if (angle_st < 1) { angle_st1 = 1; angle_en1 = angle_en; angle_st2 = n_angles + angle_st; angle_en2 = n_angles; }

		else if (n_angles < angle_en) { angle_st1 = angle_st; angle_en1 = n_angles; angle_st2 = 1; angle_en2 = angle_en - n_angles; }

		else { angle_st1 = angle_st; angle_en1 = angle_en;  angle_st2 = 1; angle_en2 = 0; }

		for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

			angle_alpha_log_max_smoothed[angle] = angle_alpha_log_max_smoothed[angle] + angle_alpha_log_max[angle_tmp];

		}

		for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

			angle_alpha_log_max_smoothed[angle] = angle_alpha_log_max_smoothed[angle] + angle_alpha_log_max[angle_tmp];

		}

		angle_alpha_log_max_smoothed[angle] = angle_alpha_log_max_smoothed[angle] / (angle_smooth_width * 2 + 1);

		printf("%5d, %8d, %7d, %10.5f, %9.5f\n" , angle, angle_n_visitors[angle], angle_n_yamaps[angle], angle_alpha_log_max_smoothed[angle] * alpha_scale, likelihood_max);

		fprintf(fpp_out_lamda_smoothed, "%5d, %8d, %7d, %10.5f, %9.5f\n", angle, angle_n_visitors[angle], angle_n_yamaps[angle], angle_alpha_log_max_smoothed[angle] * alpha_scale, likelihood_max);

	}

	return(0);


}

long calc_ks() {

	for (angle = 1; angle <= n_angles; angle++) {

		for (year = 2; year <= n_years; year++) {

			visitor1 = visitor2 = 1; ks = 0.0; ks_min = 10.0; ks_max = -10.0;

			while (visitor1 <= angle_year_n_visitors[angle][1] && visitor2 <= angle_year_n_visitors[angle][year]) {

				if (angle_year_visitor_r[angle][1][visitor1] < angle_year_visitor_r[angle][year][visitor2]) {

					ks = ks + 1.0 / (double)angle_year_n_visitors[angle][1]; visitor1++; if (ks_max < ks) { ks_max = ks; }

				}

				else {

					ks = ks - 1.0 / (double)angle_year_n_visitors[angle][year]; visitor2++; if (ks < ks_min) { ks_min = ks; }

				}

				//				printf("%4d %4d\n", visitor1, visitor2);

			}

			if (fabs(ks_max) < fabs(ks_min)) {

				angle_year_lamda[angle][year] = (double)ks_min / sqrt((double)(angle_year_n_visitors[angle][1] + angle_year_n_visitors[angle][year]));

			}

			else {

				angle_year_lamda[angle][year] = (double)ks_max / sqrt((double)(angle_year_n_visitors[angle][1] + angle_year_n_visitors[angle][year]));

			}

			//			printf(" %3d, [%6d, %6d], [%6d, %6d], %16.10f\n", angle, ks_min, ks_max, angle_year_n_visitors[angle][1], angle_year_n_visitors[angle][year], angle_year_lamda[angle][year]);

		}

		for (season = 1; season <= n_seasons; season++) {

			visitor1 = visitor2 = 1; ks = 0.0; ks_min = 10.0; ks_max = -10.0;

			while (visitor1 <= angle_n_visitors[angle] && visitor2 <= angle_season_n_visitors[angle][season]) {

				if (angle_visitor_r[angle][visitor1] < angle_season_visitor_r[angle][season][visitor2]) {

					ks = ks + 1.0 / (double)angle_n_visitors[angle]; visitor1++; if (ks_max < ks) { ks_max = ks; }

				}

				else {

					ks = ks - 1.0 / (double)angle_season_n_visitors[angle][season]; visitor2++; if (ks < ks_min) { ks_min = ks; }

				}

				//				printf("%4d %4d\n", visitor1, visitor2);

			}

			if (fabs(ks_max) < fabs(ks_min)) {

				angle_season_lamda[angle][season] = (double)ks_min / sqrt((double)(angle_n_visitors[angle] + angle_season_n_visitors[angle][season]));

			}

			else {

				angle_season_lamda[angle][season] = (double)ks_max / sqrt((double)(angle_n_visitors[angle] + angle_season_n_visitors[angle][season]));

			}

			//			printf(" %3d, [%6d, %6d], [%6d, %6d], %16.10f\n", angle, ks_min, ks_max, angle_year_n_visitors[angle][1], angle_year_n_visitors[angle][year], angle_year_lamda[angle][year]);

		}


	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_st = angle - angle_smooth_width; angle_en = angle + angle_smooth_width;

		if (angle_st < 1) { angle_st1 = 1; angle_en1 = angle_en; angle_st2 = n_angles + angle_st; angle_en2 = n_angles; }

		else if (n_angles < angle_en) { angle_st1 = angle_st; angle_en1 = n_angles; angle_st2 = 1; angle_en2 = angle_en - n_angles; }

		else { angle_st1 = angle_st; angle_en1 = angle_en;  angle_st2 = 1; angle_en2 = 0; }

		for (year = 2; year <= n_years; year++) {

			angle_year_lamda_smoothed[angle][year] = 0.0;

			for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

				angle_year_lamda_smoothed[angle][year] = angle_year_lamda_smoothed[angle][year] + angle_year_lamda[angle_tmp][year];

			}

			for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

				angle_year_lamda_smoothed[angle][year] = angle_year_lamda_smoothed[angle][year] + angle_year_lamda[angle_tmp][year];

			}

			angle_year_lamda_smoothed[angle][year] = angle_year_lamda_smoothed[angle][year] / (angle_smooth_width * 2 + 1);

		}

		for (season = 1; season <= n_seasons; season++) {

			angle_season_lamda_smoothed[angle][season] = 0.0;

			for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

				angle_season_lamda_smoothed[angle][season] = angle_season_lamda_smoothed[angle][season] + angle_season_lamda[angle][season];

			}

			for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

				angle_season_lamda_smoothed[angle][season] = angle_season_lamda_smoothed[angle][season] + angle_season_lamda[angle][season];

			}

			angle_season_lamda_smoothed[angle][season] = angle_season_lamda_smoothed[angle][season] / (angle_smooth_width * 2 + 1);

		}

	}

	for (angle = 1; angle <= n_angles; angle++) {

		for (year = 2; year <= n_years; year++) {

			printf(" %3d,           %16.14f\n", angle, lamda_scale * angle_year_lamda_smoothed[angle][year]);

			xx = (lamda_origin + lamda_scale * angle_year_lamda_smoothed[angle][year]) * sin((double)angle * angle_interval);

			yy = (lamda_origin + lamda_scale * angle_year_lamda_smoothed[angle][year]) * cos((double)angle * angle_interval);

			fprintf(*fpp_out_year_ks[year], " %3d,           %16.14f,           %16.14f,           %16.14f\n", angle, lamda_scale * angle_year_lamda[angle][year], xx, yy);

		}

		for (season = 1; season <= n_seasons; season++) {

			printf(" %3d,           %16.14f\n", angle, lamda_scale * angle_season_lamda_smoothed[angle][season]);

			xx = (lamda_origin + lamda_scale * angle_season_lamda_smoothed[angle][season]) * sin((double)angle * angle_interval);

			yy = (lamda_origin + lamda_scale * angle_season_lamda_smoothed[angle][season]) * cos((double)angle * angle_interval);

			fprintf(*fpp_out_season_ks[season], " %3d,           %16.14f,           %16.14f,           %16.14f\n", angle, lamda_scale * angle_season_lamda[angle][season], xx, yy);

		}


	}

	for (angle = 1; angle <= n_angles; angle++) {

		for (year = 2; year <= n_years; year++) {

			printf(" %3d,           %16.14f\n", angle, lamda_origin);

			xx = lamda_origin * sin((double)angle * angle_interval);

			yy = lamda_origin * cos((double)angle * angle_interval);

			fprintf(*fpp_out_year_ks[year], " %3d,           %16.14f,           %16.14f,           %16.14f\n", angle, angle_year_lamda[angle][year], xx, yy);

		}

		for (season = 1; season <= n_seasons; season++) {

			printf(" %3d,           %16.14f\n", angle, lamda_origin);

			xx = lamda_origin * sin((double)angle * angle_interval);

			yy = lamda_origin * cos((double)angle * angle_interval);

			fprintf(*fpp_out_season_ks[season], " %3d,           %16.14f,           %16.14f,           %16.14f\n", angle, angle_season_lamda[angle][season], xx, yy);

		}

	}


	return(0);

}

long calc_ratio_contours() {

	for (angle = 1; angle <= n_angles; angle++) {

		for (season = 1; season <= n_seasons; season++) {

			for (ratio = 1; ratio < n_ratios; ratio++) {

				angle_season_ratio_visitor_smoothed_r[angle][season][ratio] = 0.0;

				i = angle_season_n_visitors[angle][season] * ((double)ratio / (double)n_ratios);

				angle_season_ratio_visitor_r[angle][season][ratio] = angle_season_visitor_r[angle][season][i];

			}

			if (n_visitors_max_season <= angle_season_n_visitors[angle][season]) { n_visitors_max_season = angle_season_n_visitors[angle][season]; }

		}

		for (year = 1; year <= n_years; year++) {

			for (ratio = 1; ratio < n_ratios; ratio++) {

				angle_year_ratio_visitor_smoothed_r[angle][year][ratio] = 0.0;

				i = angle_year_n_visitors[angle][year] * ((double)ratio / (double)n_ratios);

				angle_year_ratio_visitor_r[angle][year][ratio] = angle_year_visitor_r[angle][year][i];

			}

			if (n_visitors_max_year <= angle_year_n_visitors[angle][year]) { n_visitors_max_year = angle_year_n_visitors[angle][year]; }

		}

		for (ratio = 1; ratio < n_ratios; ratio++) {

			i = angle_n_visitors[angle] * ((double)ratio / (double)n_ratios);

			angle_ratio_visitor_r[angle][ratio] = angle_visitor_r[angle][i];

		}

	}

	for (angle = 1; angle <= n_angles; angle++) {

		angle_st = angle - angle_smooth_width; angle_en = angle + angle_smooth_width;

		if (angle_st < 1) { angle_st1 = 1; angle_en1 = angle_en; angle_st2 = n_angles + angle_st; angle_en2 = n_angles; }

		else if (n_angles < angle_en) { angle_st1 = angle_st; angle_en1 = n_angles; angle_st2 = 1; angle_en2 = angle_en - n_angles; }

		else { angle_st1 = angle_st; angle_en1 = angle_en;  angle_st2 = 1; angle_en2 = 0; }

		for (ratio = 1; ratio < n_ratios; ratio++) {

			angle_ratio_visitor_smoothed_r[angle][ratio] = 0.0;

			//			sub = smoothing_month();

			for (season = 1; season <= n_seasons; season++) {

				for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

					angle_season_ratio_visitor_smoothed_r[angle][season][ratio] = angle_season_ratio_visitor_smoothed_r[angle][season][ratio] + angle_season_ratio_visitor_r[angle_tmp][season][ratio];

				}

				for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

					angle_season_ratio_visitor_smoothed_r[angle][season][ratio] = angle_season_ratio_visitor_smoothed_r[angle][season][ratio] + angle_season_ratio_visitor_r[angle_tmp][season][ratio];

				}

				angle_season_ratio_visitor_smoothed_r[angle][season][ratio] = angle_season_ratio_visitor_smoothed_r[angle][season][ratio] / (angle_smooth_width * 2 + 1);

				angle_season_ratio_visitor_smoothed_x[angle][season][ratio] = angle_season_ratio_visitor_smoothed_r[angle][season][ratio] * sin((double)angle * angle_interval) + azuma_x;

				angle_season_ratio_visitor_smoothed_y[angle][season][ratio] = angle_season_ratio_visitor_smoothed_r[angle][season][ratio] * cos((double)angle * angle_interval) + azuma_y;

			}

			for (year = 1; year <= n_years; year++) {

				for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

					angle_year_ratio_visitor_smoothed_r[angle][year][ratio] = angle_year_ratio_visitor_smoothed_r[angle][year][ratio] + angle_year_ratio_visitor_r[angle_tmp][year][ratio];

				}

				for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

					angle_year_ratio_visitor_smoothed_r[angle][year][ratio] = angle_year_ratio_visitor_smoothed_r[angle][year][ratio] + angle_year_ratio_visitor_r[angle_tmp][year][ratio];

				}

				angle_year_ratio_visitor_smoothed_r[angle][year][ratio] = angle_year_ratio_visitor_smoothed_r[angle][year][ratio] / (angle_smooth_width * 2 + 1);

				angle_year_ratio_visitor_smoothed_x[angle][year][ratio] = angle_year_ratio_visitor_smoothed_r[angle][year][ratio] * sin((double)angle * angle_interval) + azuma_x;

				angle_year_ratio_visitor_smoothed_y[angle][year][ratio] = angle_year_ratio_visitor_smoothed_r[angle][year][ratio] * cos((double)angle * angle_interval) + azuma_y;

			}

			for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

				angle_ratio_visitor_smoothed_r[angle][ratio] = angle_ratio_visitor_smoothed_r[angle][ratio] + angle_ratio_visitor_r[angle_tmp][ratio];

			}

			for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

				angle_ratio_visitor_smoothed_r[angle][ratio] = angle_ratio_visitor_smoothed_r[angle][ratio] + angle_ratio_visitor_r[angle_tmp][ratio];

			}

			angle_ratio_visitor_smoothed_r[angle][ratio] = angle_ratio_visitor_smoothed_r[angle][ratio] / (angle_smooth_width * 2 + 1);

			angle_ratio_visitor_smoothed_x[angle][ratio] = angle_ratio_visitor_smoothed_r[angle][ratio] * sin((double)angle * angle_interval) + azuma_x;

			angle_ratio_visitor_smoothed_y[angle][ratio] = angle_ratio_visitor_smoothed_r[angle][ratio] * cos((double)angle * angle_interval) + azuma_y;

		}

	}

	for (angle = 1; angle <= n_angles; angle++) {

		fprintf(fpp_out_all_50, "%3d, %16.2f, %16.2f\n", angle, angle_ratio_visitor_smoothed_x[angle][2], angle_ratio_visitor_smoothed_y[angle][2]);

//		printf("%3d, %16.2f, %16.2f\n", angle, angle_ratio_visitor_smoothed_x[angle][3], angle_ratio_visitor_smoothed_y[angle][3]);

//		fprintf(fpp_out_all_75, "%3d, %16.2f, %16.2f\n", angle, angle_ratio_visitor_smoothed_x[angle][3], angle_ratio_visitor_smoothed_y[angle][3]);

		for (season = 1; season <= n_seasons; season++) {

			fprintf(*fpp_out_season_50[season], "%3d, %16.2f, %16.2f\n", angle, angle_season_ratio_visitor_smoothed_x[angle][season][2], angle_season_ratio_visitor_smoothed_y[angle][season][2]);

			fprintf(*fpp_out_season_75[season], "%3d, %16.2f, %16.2f\n", angle, angle_season_ratio_visitor_smoothed_x[angle][season][3], angle_season_ratio_visitor_smoothed_y[angle][season][3]);

		}

		for (year = 1; year <= n_years; year++) {

			fprintf(*fpp_out_year_50[year], "%3d, %16.2f, %16.2f\n", angle, angle_year_ratio_visitor_smoothed_x[angle][year][2], angle_year_ratio_visitor_smoothed_y[angle][year][2]);

			fprintf(*fpp_out_year_75[year], "%3d, %16.2f, %16.2f\n", angle, angle_year_ratio_visitor_smoothed_x[angle][year][3], angle_year_ratio_visitor_smoothed_y[angle][year][3]);

		}

	}

	return(0);

}

long sort_all() {

	for (angle = 1; angle <= n_angles; angle++) {

		for (season = 1; season <= n_seasons; season++) {

			for (i = 1; i < angle_season_n_visitors[angle][season]; i++) {

				for (j = i + 1; j <= angle_season_n_visitors[angle][season]; j++) {

					if (angle_season_visitor_r[angle][season][j] < angle_season_visitor_r[angle][season][i]) {

						ii = angle_season_visitor_r[angle][season][i]; angle_season_visitor_r[angle][season][i] = angle_season_visitor_r[angle][season][j];  angle_season_visitor_r[angle][season][j] = ii;

					}

				}

			}

		}

		for (year = 1; year <= n_years; year++) {

			for (i = 1; i < angle_year_n_visitors[angle][year]; i++) {

				for (j = i + 1; j <= angle_year_n_visitors[angle][year]; j++) {

					if (angle_year_visitor_r[angle][year][j] < angle_year_visitor_r[angle][year][i]) {

						ii = angle_year_visitor_r[angle][year][i]; angle_year_visitor_r[angle][year][i] = angle_year_visitor_r[angle][year][j];  angle_year_visitor_r[angle][year][j] = ii;

					}

				}

			}

		}

		for (i = 1; i < angle_n_visitors[angle]; i++) {

			for (j = i + 1; j <= angle_n_visitors[angle]; j++) {

				if (angle_visitor_r[angle][j] < angle_visitor_r[angle][i]) {

					ii = angle_visitor_r[angle][i]; angle_visitor_r[angle][i] = angle_visitor_r[angle][j];  angle_visitor_r[angle][j] = ii;

				}

			}

		}

	}

	return(0);

}

long sort_month()
{

	for (angle = 1; angle <= n_angles; angle++) {

		for (month = 1; month <= n_months; month++) {

			for (ratio = 1; ratio < n_ratios; ratio++) { angle_month_ratio_visitor_smoothed_r[angle][month][ratio] = 0.0; }

			for (i = 1; i < angle_month_n_visitors[angle][month]; i++) {

				for (j = i + 1; j <= angle_month_n_visitors[angle][month]; j++) {

					if (angle_month_visitor_r[angle][month][j] < angle_month_visitor_r[angle][month][i]) {

						ii = angle_month_visitor_r[angle][month][i]; angle_month_visitor_r[angle][month][i] = angle_month_visitor_r[angle][month][j];  angle_month_visitor_r[angle][month][j] = ii;

					}

				}

			}

			for (ratio = 1; ratio < n_ratios; ratio++) {

				i = angle_month_n_visitors[angle][month] * ((double)ratio / (double)n_ratios);

				//				printf("%3d %3d\n", i, angle_month_n_visitors[angle][month]);

				angle_month_ratio_visitor_r[angle][month][ratio] = angle_month_visitor_r[angle][month][i];

			}

			if (n_visitors_max_month <= angle_month_n_visitors[angle][month]) { n_visitors_max_month = angle_month_n_visitors[angle][month]; }

		}
	}

	return(0);

}

long smoothing_month() {

	for (month = 1; month <= n_months; month++) {

		for (angle_tmp = angle_st1; angle_tmp <= angle_en1; angle_tmp++) {

			angle_month_ratio_visitor_smoothed_r[angle][month][ratio] = angle_month_ratio_visitor_smoothed_r[angle][month][ratio] + angle_month_ratio_visitor_r[angle_tmp][month][ratio];

		}

		for (angle_tmp = angle_st2; angle_tmp <= angle_en2; angle_tmp++) {

			angle_month_ratio_visitor_smoothed_r[angle][month][ratio] = angle_month_ratio_visitor_smoothed_r[angle][month][ratio] + angle_month_ratio_visitor_r[angle_tmp][month][ratio];

		}

		angle_month_ratio_visitor_smoothed_r[angle][month][ratio] = angle_month_ratio_visitor_smoothed_r[angle][month][ratio] / (angle_smooth_width * 2 + 1);

		angle_month_ratio_visitor_smoothed_x[angle][month][ratio] = angle_month_ratio_visitor_smoothed_r[angle][month][ratio] * sin((double)angle * angle_interval) + azuma_x;

		angle_month_ratio_visitor_smoothed_y[angle][month][ratio] = angle_month_ratio_visitor_smoothed_r[angle][month][ratio] * cos((double)angle * angle_interval) + azuma_y;

	}

	return(0);

}

long read_input_yamap()
{

	long v01, v02, v03, v04, v05, v06, v07, v08, v09, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36;

	errno_t error;
	FILE* fpp, * fpp_out, * fpp_test, * fpp_check, * fpp_r_max;

	if ((error = fopen_s(&fpp, "Yamap.csv", "r")) != 0) { printf("File not open\n"); exit(1); }

	fopen_s(&fpp_test, "Yamap_test.csv", "w+");

	fopen_s(&fpp_check, "Yamap_check.csv", "w+");

	fopen_s(&fpp_r_max, "R_max.csv", "w+");

	fprintf(fpp_check, " Id,                 X,                Y\n");

	city = 0;

	while (fscanf_s(fpp, "%d, %lf, %lf, %lf, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d"
		, &id, &xx, &yy, &area, &v01, &v02, &v03, &v04, &v05, &v06, &v07, &v08, &v09, &v10, &v11, &v12, &v13, &v14, &v15, &v16, &v17, &v18, &v19, &v20, &v21, &v22, &v23, &v24, &v25, &v26, &v27, &v28, &v29, &v30, &v31, &v32, &v33, &v34, &v35, &v36) != EOF) {

		city++;

		city_to_id[city] = id; id_to_city[id] = city;

		city_x[city] = xx; city_y[city] = yy; city_area[city] = area * 10000.0; city_r[city] = sqrt(city_area[city] / 2.0 / pi);

		//		printf("%3d, %16.2f\n", city, city_area[city]);

		city_month_n_yamaps[city][1] = v01; city_month_n_yamaps[city][2] = v02; city_month_n_yamaps[city][3] = v03; city_month_n_yamaps[city][4] = v04; city_month_n_yamaps[city][5] = v05;
		city_month_n_yamaps[city][6] = v06; city_month_n_yamaps[city][7] = v07; city_month_n_yamaps[city][8] = v08; city_month_n_yamaps[city][9] = v09; city_month_n_yamaps[city][10] = v10;
		city_month_n_yamaps[city][11] = v11; city_month_n_yamaps[city][12] = v12; city_month_n_yamaps[city][13] = v13; city_month_n_yamaps[city][14] = v14; city_month_n_yamaps[city][15] = v15;
		city_month_n_yamaps[city][16] = v16; city_month_n_yamaps[city][17] = v17; city_month_n_yamaps[city][18] = v18; city_month_n_yamaps[city][19] = v19; city_month_n_yamaps[city][20] = v20;
		city_month_n_yamaps[city][21] = v21; city_month_n_yamaps[city][22] = v22; city_month_n_yamaps[city][23] = v23; city_month_n_yamaps[city][24] = v24; city_month_n_yamaps[city][25] = v25;
		city_month_n_yamaps[city][26] = v26; city_month_n_yamaps[city][27] = v27; city_month_n_yamaps[city][28] = v28; city_month_n_yamaps[city][29] = v29; city_month_n_yamaps[city][30] = v30;
		city_month_n_yamaps[city][31] = v31; city_month_n_yamaps[city][32] = v32; city_month_n_yamaps[city][33] = v33; city_month_n_yamaps[city][34] = v34; city_month_n_yamaps[city][35] = v35;
		city_month_n_yamaps[city][36] = v36;

	}

	n_cities = city;

	for (angle = 1; angle <= n_angles; angle++) { angle_r_max[angle] = 0; }

	for (city = 1; city <= n_cities; city++) {

		for (month = 1; month <= n_months; month++) {

			for (yamap = 1; yamap <= city_month_n_yamaps[city][month] / yamap_ratio; yamap++) {

				uu = rand() / 32768.0; vv = sqrt(rand() / 32768.0);

				theta = 2.0 * pi * uu; rr = city_r[city] * vv;

				xx = city_x[city] + rr * cos(theta);

				yy = city_y[city] + rr * sin(theta);

				dx = xx - azuma_x; dy = yy - azuma_y;

				rr = sqrt(dx * dx + dy * dy);

				//				if (2000000 < rr) { if (angle == 24) { printf("\n"); } }

				theta = atan(dx / dy);

				//				printf("%16.8f %16.8f %12.8f\n", dx, dy, theta);

				if (dx < 0.0 && 0.0 < dy) { theta = theta + 2.0 * pi; }

				else if (0.0 < dx && dy < 0.0) { theta = theta + pi; }

				else if (dx < 0.0 && dy < 0.0) { theta = theta + pi; }

				angle = floor(theta / (double)angle_interval) + 1;

				angle_month_n_yamaps[angle][month]++;

				angle_month_yamap_r[angle][month][angle_month_n_yamaps[angle][month]] = rr;

				season = month_to_season[month]; year = month_to_year[month];

				angle_season_n_yamaps[angle][season]++;

				angle_season_yamap_r[angle][season][angle_season_n_yamaps[angle][season]] = rr;

				angle_year_n_yamaps[angle][year]++;

				angle_year_yamap_r[angle][year][angle_year_n_yamaps[angle][year]] = rr;

				angle_n_yamaps[angle]++;

				angle_yamap_r[angle][angle_n_yamaps[angle]] = rr;

				if (angle_r_max[angle] < rr) { angle_r_max[angle] = rr; }

			}

		}

	}

	//	for (city = 1; city <= n_cities; city++) { printf("%4d (%5d) %16.2f %16.2f %16.2f", city, city_to_id[city], city_x[city], city_y[city], city_area[city]); for (month = 1; month <= month_max; month++) { printf("%5d", city_month_n_yamaps[city][month]); } printf("\n"); }

	for (angle = 1; angle <= n_angles; angle++) { fprintf(fpp_r_max, "%12.0d, ", angle_r_max[angle]); } fprintf(fpp_r_max, "\n");

	fclose(fpp); fclose(fpp_test); fclose(fpp_check); fclose(fpp_r_max);

	return(0);

}

long read_input()
{

	long v01, v02, v03, v04, v05, v06, v07, v08, v09, v10, v11, v12, v13, v14, v15, v16, v17, v18, v19, v20, v21, v22, v23, v24, v25, v26, v27, v28, v29, v30, v31, v32, v33, v34, v35, v36;

	errno_t error;
	FILE* fpp, * fpp_out, * fpp_test, * fpp_check;

	if ((error = fopen_s(&fpp, "Azuma.csv", "r")) != 0) { printf("File not open\n"); exit(1); }

	fopen_s(&fpp_test, "Azuma_test.csv", "w+");

	fopen_s(&fpp_check, "Azuma_check.csv", "w+");

	fprintf(fpp_check, " Id,                 X,                Y\n");

	city = 0;

	n_visitors = 0;

	while (fscanf_s(fpp, "%d, %lf, %lf, %lf, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d, %d"
		, &id, &xx, &yy, &area, &v01, &v02, &v03, &v04, &v05, &v06, &v07, &v08, &v09, &v10, &v11, &v13, &v14, &v15, &v16, &v17, &v18, &v19, &v20, &v21, &v22, &v23, &v24, &v25, &v26, &v27, &v28, &v29, &v30, &v31, &v32, &v33, &v34, &v35, &v36) != EOF) {

		v12 = 0;

		city++;

		city_to_id[city] = id; id_to_city[id] = city;

		city_x[city] = xx; city_y[city] = yy; city_area[city] = area * 10000.0; city_r[city] = sqrt(city_area[city] / 2.0 / pi);

//		printf("%3d, %16.2f\n", city, city_area[city]);

		city_month_n_visitors[city][1] = v01; city_month_n_visitors[city][2] = v02; city_month_n_visitors[city][3] = v03; city_month_n_visitors[city][4] = v04; city_month_n_visitors[city][5] = v05;
		city_month_n_visitors[city][6] = v06; city_month_n_visitors[city][7] = v07; city_month_n_visitors[city][8] = v08; city_month_n_visitors[city][9] = v09; city_month_n_visitors[city][10] = v10;
		city_month_n_visitors[city][11] = v11; city_month_n_visitors[city][12] = v12; city_month_n_visitors[city][13] = v13; city_month_n_visitors[city][14] = v14; city_month_n_visitors[city][15] = v15;
		city_month_n_visitors[city][16] = v16; city_month_n_visitors[city][17] = v17; city_month_n_visitors[city][18] = v18; city_month_n_visitors[city][19] = v19; city_month_n_visitors[city][20] = v20;
		city_month_n_visitors[city][21] = v21; city_month_n_visitors[city][22] = v22; city_month_n_visitors[city][23] = v23; city_month_n_visitors[city][24] = v24; city_month_n_visitors[city][25] = v25;
		city_month_n_visitors[city][26] = v26; city_month_n_visitors[city][27] = v27; city_month_n_visitors[city][28] = v28; city_month_n_visitors[city][29] = v29; city_month_n_visitors[city][30] = v30;
		city_month_n_visitors[city][31] = v31; city_month_n_visitors[city][32] = v32; city_month_n_visitors[city][33] = v33; city_month_n_visitors[city][34] = v34; city_month_n_visitors[city][35] = v35;
		city_month_n_visitors[city][36] = v36;

	}

	n_cities = city;

	for (city = 1; city <= n_cities; city++) {

		for (month = 1; month <= n_months; month++) {

			for (visitor = 1; visitor <= city_month_n_visitors[city][month]; visitor++) {

				uu = rand() / 32768.0; vv = sqrt(rand() / 32768.0);

				theta = 2.0 * pi * uu; rr = city_r[city] * vv;

				xx = city_x[city] + rr * cos(theta);

				yy = city_y[city] + rr * sin(theta);

				dx = xx - azuma_x; dy = yy - azuma_y;

				rr = sqrt(dx * dx + dy * dy);

//				if (2000000 < rr) { if (angle == 24) { printf("\n"); } }

				theta = atan(dx / dy);

//				printf("%16.8f %16.8f %12.8f\n", dx, dy, theta);

				if (dx < 0.0 && 0.0 < dy) { theta = theta + 2.0 * pi; }

				else if (0.0 < dx && dy < 0.0) { theta = theta + pi; }

				else if (dx < 0.0 && dy < 0.0) { theta = theta + pi; }

				angle = floor(theta / (double)angle_interval) + 1;

				angle_month_n_visitors[angle][month]++;

				angle_month_visitor_r[angle][month][angle_month_n_visitors[angle][month]] = rr;

				season = month_to_season[month]; year = month_to_year[month];

				angle_season_n_visitors[angle][season]++;

				angle_season_visitor_r[angle][season][angle_season_n_visitors[angle][season]] = rr;

				angle_year_n_visitors[angle][year]++;

				angle_year_visitor_r[angle][year][angle_year_n_visitors[angle][year]] = rr;

				angle_n_visitors[angle]++;

				angle_visitor_r[angle][angle_n_visitors[angle]] = rr;

				n_visitors++;

/*				if (city == 15 && month == 2) {

					printf("%3d, %16d, %16d\n", angle, city_month_visitor_x[city][month][visitor], city_month_visitor_y[city][month][visitor]);

					fprintf(fpp_check, "%3d, %16.2f, %16.2f\n", angle, city_month_visitor_x[city][month][visitor], city_month_visitor_y[city][month][visitor]);

				} */
				
// if (month == 1) { fprintf(fpp_test, "%20.16F, %20.16f\n", city_month_visitor_x[city][month][visitor], city_month_visitor_y[city][month][visitor]); }

//	if (month == 1) { printf("%20.16F, %20.16f\n", city_month_visitor_x[city][month][visitor], city_month_visitor_y[city][month][visitor]); }

			}

		}

	}

	n_visitors_max_month = n_visitors_max_season = n_visitors_max_year = n_visitors_max = 0;

	for (angle = 1; angle <= n_angles; angle++) {

		for (month = 1; month <= n_months; month++) {

			if(n_visitors_max_month < angle_month_n_visitors[angle][month]){ n_visitors_max_month = angle_month_n_visitors[angle][month]; }
		}

		for (season = 1; season <= n_seasons; season++) {

			if (n_visitors_max_season < angle_season_n_visitors[angle][season]) { n_visitors_max_season = angle_season_n_visitors[angle][season]; }

		}

		for (year = 1; year <= n_years; year++) {

			if (n_visitors_max_year < angle_year_n_visitors[angle][year]) { n_visitors_max_year = angle_year_n_visitors[angle][year]; }

		}

		if (n_visitors_max < angle_n_visitors[angle]) { n_visitors_max = angle_n_visitors[angle]; }

	}


	//	for (city = 1; city <= n_cities; city++) { printf("%4d (%5d) %16.2f %16.2f %16.2f", city, city_to_id[city], city_x[city], city_y[city], city_area[city]); for (month = 1; month <= month_max; month++) { printf("%5d", city_month_n_visitors[city][month]); } printf("\n"); }

	fclose(fpp); fclose(fpp_test); fclose(fpp_check);

	return(0);

}